;		Modem PR 1K2/2K4

; vyznam registrov
;	konst = time(s)/6
;	R4 konstanta pri RX
;	R5 hlavna casova slucka
;	R6 slucka pri TX
;	833,3s/1666,6 1200Hz
;	454,5s/907,0  2200Hz

;namerane hodnoty:
;	12.0 MHz R5 = 1	456s	=2193 Hz
;	12.0 MHz R5 = 5	825s	=1212 Hz (+ nop)
;	24.0 MHz R5 = 6	907s	=2205 Hz (+ nop)
;	24.0 MHz R5 =15	1645s	=1216 Hz (+ nop)
;	24.0 MHz R5 = 1	228s 	=4386 Hz
;	24.0 MHz R5 = 5 412.5s	=2424 Hz (+ nop)

;hodnoty su x2 lebo su simulovane pri 12.000 MHz X-tal
;v skutosnosti bude 24.000 MHz

vzorky	equ	41
time_0	equ	15
time_1	equ	6
time_2	equ	5
time_3	equ	1
konst1	equ	46		;280s
konst2	equ	23		;140s

RXDAT	bit	P3.0		;in	data prijem
TXDAT	bit	P3.1		;out	data vysielanie
TXDNG	bit	P3.2		;out	data neg vysielanie
PTT	bit	P3.3		;in	vysielanie PTT=1
SEL	bit	P3.5		;in	vyber 0=1K2, 1=2K4
TXNEG	bit	P3.7		;out	vysielanie=0

	org	0h
	sjmp	inic
	org	30h
inic:	mov	SP,#2Fh		;inicializacia
	mov	DPTR,#sin1
	mov	P3,#255
	sjmp	select

read:	setb	TXNEG		;program pre prijem
read0s:	mov	A,R4		;test log 0
	mov	R5,A
read0n:	nop			;caka polovicku casu
	nop
	jb	PTT,select
	djnz	R5,read0n
	mov	A,R4
	mov	R5,A
read0:	jb	P3.6,read0b	;druhu polovicku testuje
	jb	PTT,select
	djnz	R5,read0
	clr	TXDAT		;je dlhsia
	setb	TXDNG
read0a:	jb	PTT,select
	jnb	P3.6,read0a
	sjmp	read1s
read0b:	setb	TXDAT		;je kratsia
	clr	TXDNG
read1s:	mov	A,R4		;test log 1
	mov	R5,A
read1n:	nop			;caka polovicku casu
	nop
	jb	PTT,select
	djnz	R5,read1n
	mov	A,R4
	mov	R5,A
read1:	jnb	P3.6,read1b	;druhu polovicku testuje
	jb	PTT,select
	djnz	R5,read1
	clr	TXDAT		;je dlhsia
	setb	TXDNG
read1a:	jb	PTT,select
	jb	P3.6,read1a
	sjmp	select
read1b:	setb	TXDAT		;je kratsia
	clr	TXDNG

select:	jb	SEL,set2k4
	mov	R4,#konst1
	jnb	PTT,read
	clr	TXNEG
sin1k2:	jnb	PTT,select
	mov	R6,#vzorky	;zaciatok generovania sinusu
cyk1k2:	mov	A,R6
	movc	A,@A+DPTR
	mov	P1,A
	jb	RXDAT,tim1k2
	mov	R5,#time_0
	nop			;nop
	djnz	R5,$
	djnz	R6,cyk1k2
	sjmp	sin1k2
tim1k2:	mov	R5,#time_1
	nop			;nop
	djnz	R5,$
	djnz	R6,cyk1k2
	sjmp	sin1k2

set2k4:	mov	R4,#konst2
	jnb	PTT,read
	clr	TXNEG
sin2k4:	jnb	PTT,select
	mov	R6,#vzorky
cyk2k4:	mov	A,R6
	movc	A,@A+DPTR
	mov	P1,A
	jb	RXDAT,tim2k4
	mov	R5,#time_2
	nop				; nop
	djnz	R5,$
	djnz	R6,cyk2k4
	sjmp	sin2k4
tim2k4:	mov	R5,#time_3
	djnz	R5,$
	djnz	R6,cyk2k4
	sjmp	sin2k4

sin1:	ds	1		;posun o 1 bajt
	db	131
	db	147
	db	167
	db	183
	db	199
	db	215
	db	227
	db	235
	db	243
	db	247
	db	251
	db	251
	db	247
	db	239
	db	231
	db	219
	db	207
	db	191
	db	175
	db	155
	db	139
	db	119
	db	103
	db	83
	db	67
	db	51
	db	39
	db	27
	db	19
	db	11
	db	7
	db	7
	db	11
	db	15
	db	23
	db	31
	db	43
	db	59
	db	75
	db	91
	db	111


	end